<?php
/*
Plugin Name: &bull; Hobo WP Custom Link Love
Plugin URI: http://www.hobo-web.co.uk
Description: Custom Variation of Lucia LinkyLove to conserve Google Pagerank, Instead of adding rel="nofollow" we wont Link to the Authors URL at all until they have contributed a number of intelligent comments.
Author: Shaun Anderson / Martin Gardner of Hobo SEO
Version: 0.9 Beta 
Author URI: http://www.hobo-web.co.uk/
*/
/*
*Copyright (c) 2007 Lucia Liljegren
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer
*    in the documentation and/or other materials provided with the
*    distribution.
* 3. The name of the author may not be used to endorse or promote
*    products derived from this software without specific prior
*    written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
add_action('admin_menu', 'HoboCustomLinkLove_admin_menu');	
	
add_filter('get_comment_author_link', 'adjust_nofollow_author',11);
add_filter('comment_text', 'adjust_nofollow_text',11);	
add_action('loop_end', 'addHoboCustomLinkLoveLink'); 
add_action('publish_post', 'updateHoboCustomLinkLoveDate');
load_plugin_textdomain('hobo-custom-linkylove', false, dirname( plugin_basename(__FILE__) ) . '/lang');

	function updateHoboCustomLinkLoveDate() {
		$lastposts = get_posts('numberposts=1');		
		foreach($lastposts as $post) {
			setup_postdata($post);
			the_title(); 
			$lastLinkLoveDate=$post->post_date;
			//echo('<br /> lastLinkLoveDate= '.$lastLinkLoveDate);
			update_option('lastLinkLoveDate',$lastLinkLoveDate); 
		}
	}	

	function addHoboCustomLinkLoveLink($text='') {
	// called at loop end.
		global $single, $feed, $post;
	
		$commentPolicyPage=	get_option('commentPolicyPage');
		if(!$feed && $single ){
					
			if( $commentPolicyPage==2 || ($commentPolicyPage==1 && ($post->post_date < $old_Post )) ){
				echo("<br /><a href='http://www.hobo-web.co.uk/'>Comment links Optimised by hobo.</a>");}
			
		}// feed
		return $text;
	}

	   

	function HoboCustomLinkLove_admin_menu() {
		add_options_page(
			__('HoboCustomLinkLove Options'),
			__('Hobo Link Love'), 5, basename(__FILE__),'set_HoboCustomLinkLove_options_page');
	}


	function set_HoboCustomLinkLove_options_page(){
		
		if($_POST['HoboCustomLinkLove']=='Submit'){ 
			
			$authorMatchNumber    =	min(max(floor($_POST['authorMatchNumber']),3),10);
			$commentMatchNumber   =	max(floor($_POST['theCommentMatchNumber']),-1);
			
				if(-1<$commentMatchNumber)
				{ 
					$commentMatchNumber=max($commentMatchNumber,3); 
				}
				
			$commentPolicyPage     	= $_POST['commentPolicyPage'];
			$maxCharactersInName   	= max($_POST['maxCharactersInName'],15);
			$adminNameExclude		= $_POST['adminNameExclude'];
			$HoboCustomLinkyDays	= max($_POST['HoboCustomLinkyDays'],0);
			$showCommentNumber		= $_POST['showCommentNumber'];
			
			echo('<div id="message" class="updated fade" style="background-color:#FFFBCC; text-align:center; "><p><strong>Settings Saved.</strong></p></div>');
			
			update_option('commentsMatchNumber',$commentMatchNumber); 
			update_option('authorMatchNumber',$authorMatchNumber); 
			update_option('commentPolicyPage',$commentPolicyPage); 
			update_option('maxCharactersInName',$maxCharactersInName);
			update_option('adminNameExclude',$adminNameExclude);
			update_option('HoboCustomLinkyDays',$HoboCustomLinkyDays);
			update_option('showCommentNumber',$showCommentNumber); 
			
		}
		HoboCustomLinkLoveAdminPage($text);
	}// set_HoboCustomLinkLove_options_page()
	
	
	
	function HoboCustomLinkLoveAdminPage($textAdded="")
	{
		
		updateHoboCustomLinkLoveDate(); // this will force user to update!
		
		$authorMatchNumber		= get_option('authorMatchNumber');
		$commentsMatchNumber	= get_option('commentsMatchNumber');
		$commentPolicyPage		= get_option('commentPolicyPage');
		$maxCharactersInName	= max(get_option('maxCharactersInName'),15);
		$adminNameExclude		= get_option('adminNameExclude');
		$HoboCustomLinkyDays	= get_option('HoboCustomLinkyDays');
		$showCommentNumber		= get_option('showCommentNumber');
		
			if(0<$commentsMatchNumber)
			{
				$commentsMatchNumber=max($commentsMatchNumber,$authorMatchNumber);
			}
			
			if($authorMatchNumber=='')
			{
				$commentPolicyPage=1;
			}
			
			if($showCommentNumber=="No")
			{ 
				$selectCommentNo='selected="selected"'; $selectCommentYes=''; 
			}else{ 
				$selectCommentYes='selected="selected"'; $selectCommentNo=''; 
			}
			
			if($commentPolicyPage=="0")
			{
				$selectZero='selected="selected"'; $selectOne=''; $selectTwo='';
			}else if($commentPolicyPage=="1" )
				{
					$selectOne='selected="selected"';$selectZero='';$selectTwo='';
				}else{
					$selectTwo='selected="selected"';$selectZero='';$selectOne='';
				}
				
		//echo('<br />| commentMatchNumber= '.$commentsMatchNumber.' | authorMatchNumber='.$authorMatchNumber.' | linksPerHour= '.$linksPerHour.' | linksPerDay= '.$linksPerDay.' | commentPolicyPage='.$commentPolicyPage);
		?>
        
		<?php echo "<div class=\"wrap\">"; ?>
        
        <div class="icon32" id="icon-options-general"><br/></div>
        <h2><?php _e('Hobo Custom Link Love','hobo-custom-linkylove') ?></h2>
        
		<form method="post" name="HoboCustomLinkLove">
		<h3><?php _e('Hobo Custom Link Love','hobo-custom-linkylove') ?></h3>
        <table border="0"  class="widefat">
		<tr>
			<td style="padding:10px;">
            <?php _e('Enter the number of matches when the <i>author</i> links become do follow: <br /> HCLL permits 3 through 10.','hobo-custom-linkylove') ?>
            </td>
			<td align="center" style="padding:10px;"><input type="text" name="authorMatchNumber" value="<?php echo($authorMatchNumber ) ?>" size="4" maxlength="4" ></td>
		</tr>	
		<tr>
			<td>
            <?php _e('<h4>Enter the number of matches when <i>comment</i> links become do follow:</h4><p>HCLL permits any number greater than 3 and also greater than the number entered above. If you <i>never</i> want to permit visitors to enter links in comments, enter -1.</p>','hobo-custom-linkylove') ?>
            </td>
			<td align="center" style="padding:10px;">
            	<input type="text" name="theCommentMatchNumber" value="<?php echo( $commentsMatchNumber) ?>" size="4" maxlength="4" >
             </td>
		</tr>
		
		<tr>
			<td>
            <?php _e('<h4>Keep dofollow off comments less than some number of days old?</h4><p>The default is zero, and I advise using that. BE SURE TO ENTER 0 IN THE FIELD OR THE PLUGIN MIGHT NOT WORK!<br />If you set a value greater than zero, you the blogger have an extra time buffer. Comments will be dofollows only <i>after</i> there are enough from the same visitor and even then only when a individual comment is old enough. (This option was requested and is useful if you find the same spammer arriving and suddenly leaving many comments immediately.)</p>','hobo-custom-linkylove') ?>
              </td>
			<td align="center" style="padding:10px;">
            	<input type="text" name="HoboCustomLinkyDays" value="<?php echo( $HoboCustomLinkyDays) ?>" size="5" maxlength="5" >
            </td>
		</tr>
		
		<tr>
			<td>
            <?php _e('<h4>Keep dofollow off one particular name?</h4><p>This is useful to avoid looking like you are trying to google bomb your own name. I leave comments on my own site as "Hobo", so I exclude that name.</p>','hobo-custom-linkylove') ?>
            </td>
			<td align="center" style="padding:10px;"><input type="text" name="adminNameExclude" value="<?php echo( $adminNameExclude) ?>" size="30" maxlength="30" ></td>
		</tr>	
		<tr>
			<td>
			<?php _e('<h4>Show comment count?</h4><p>If you choose yes, the number of comments by a particular visitor will appear after their name. The default is yes.</p>','hobo-custom-linkylove') ?>
            </td>
			<td align="center" style="padding:10px;">
			<select name='showCommentNumber' id='showCommentNumber' class='postform'>
			<option value="Yes" <?php echo($selectCommentYes) ?> ><?php _e('Yes, Show Number.','hobo-custom-linkylove') ?></option>
			<option value="No" <?php echo($selectCommentNo) ?> ><?php _e('No.','hobo-custom-linkylove') ?></option>
			</select>
			</td>
		</tr>		
				
		<tr>
			<td colspan='2' style="padding:10px;">
            <?php _e('<p>Permit <strong>\'dofollow\'</strong> in \'names\' with fewer than  ','hobo-custom-linkylove') ?>
            	<input type="text" name="maxCharactersInName" value="<?php echo( $maxCharactersInName) ?>" size="4" maxlength="4" >
            <?php _e('characters.</center><br />Why? Spammers often leave names like "Joe -- SEO expert" or "Cashemere Dog Sweater".<br /> You can refuse to add a \'dofollow\' if the name is too long.  HCLL will permit you to  enter any number greater than 15.</p>','hobo-custom-linkylove') ?>
            </td>
		</tr>
		
			<tr>
			<td style="padding:10px;">
            <?php _e('<p>Insert informational links telling visitors your comments are \'link optimised\' and use Hobo Custom Link Love?</p>','hobo-custom-linkylove') ?>
			</td>
			<td>
                <select name='commentPolicyPage' id='commentPolicyPage' class='postform'>
                    <option value="2" <?php echo($selectTwo) ?> ><?php _e('Yes, add links!','hobo-custom-linkylove') ?></option>
                    <option value="1" <?php echo($selectOne) ?> ><?php _e('Yes, but only to old posts.','hobo-custom-linkylove') ?></option>
                    <option value="0"  <?php echo($selectZero) ?> ><?php _e('No. I\'ll blog about HCLL instead!','hobo-custom-linkylove') ?> </option>
                </select>
            </td>
            </tr>
			<tr>
			  <td colspan='2' align="right" style="text-align: right; padding:10px;">
              <input type="submit" name="HoboCustomLinkLove" id="HoboCustomLinkLove" value="<?php echo _e('Submit','hobo-custom-linkylove')?>" class="button-primary"  /></td>
		  </tr>
		</table>
        <p>
        <small>
		<?php _e('Modified by <a href="http://www.hobo-web.co.uk/" target="_blank">Hobo</a> and based on the excellent code provided by <a href="http://money.bigbucksblogger.com" target="_blank">Lucia</a> - Learn More about Google Pagerank and SEO at Hobo!','hobo-custom-linkylove') ?>
        </small>
        </p>
<?php echo "</div>"; ?>

<?php
}// END HoboCustomLinkLoveAdminPage($textAdded="")
	
	

	function adjust_nofollow_author($text = ''){
		global $table_prefix, $wpdb, $comment, $noFollowingText, $limited_comment_count; 
		static $firstCommentLinkLove,$authorMatchNumber,$commentsMatchNumber,$linksPerHour,$linksPerDay,$commentPolicyPage,$commentAuthorURL,$commentAuthorEmail,$commentAuthorIP,$numCommentsShownSoFar,$lastLinkLoveDate,$countForMatch,$maxCharactersInName,$adminNameExclude,$HoboCustomLinkyDays,$oldCommentDate,$commentAuthorName,$showCommentNumber;
		
		if($firstCommentLinkLove !=1)
		{
			$authorMatchNumber		= max(get_option('authorMatchNumber'),3);
			$commentsMatchNumber	= get_option('commentsMatchNumber');
			$commentPolicyPage		= get_option('commentPolicyPage');	
			if(0<$commentsMatchNumber)
			{
				$commentsMatchNumber=max($commentsMatchNumber,3);
			}
			 
			if(!isset($commentPolicyPage))
			{
				$commentPolicyPage=0;
			}
			$maxCharactersInName	= max(get_option('maxCharactersInName'),15);
			$lastLinkLoveDate		= mysql2date('U', get_option('lastLinkLoveDate')); 
			$showCommentNumber		= get_option('showCommentNumber');
			$adminNameExclude		= get_option('adminNameExclude');
			$HoboCustomLinkyDays	= get_option('HoboCustomLinkyDays');
			$oldCommentDate			= time() -86400*$HoboCustomLinkyDays;
			
			$firstCommentLinkLove =1;
		}	//$firstCommentLinkLove !=1)
		
		// Now decide whether to do follow
		$limited_count=0;	// default, will count if necessary.
		
		//  only check comments that have author, url etc.		
		$daysBefore= -( mysql2date('U', $comment->comment_date) -$lastLinkLoveDate)/86400;		
	
		$sameNameExclude=strcasecmp($comment->comment_author,$adminNameExclude);
		if (!$sameNameExclude )
		{
			return $text;
		}
		
		if (($oldCommentDate <  mysql2date('U', $comment->comment_date)) ||  $daysBefore < -14 ||!$sameNameExclude )
		{
			$text .= _e('new comment','hobo-custom-linkylove')." ";
			return $text;
		}
		
	
		if(isset($comment->comment_ID) && isset($comment->comment_author) && isset($comment->comment_author_url) && isset($comment->comment_author_email) )
		{	
			// explode on '/' 
			$domainToMatch=explode('/',$comment->comment_author_url,4);
			//echo('<br /> domain? '.$domainToMatch[2]);	
				
			$lengthAuthor=strlen($comment->comment_author);
			$lengthURL=strlen($domainToMatch[2]);
			$lengthEmail=strlen($comment->comment_author_email);
			
			if ($lengthAuthor<2 ||  $lengthURL<2 ||  $lengthEmail<3  ){
				//echo('<br />short strings: return ');
				return $text;
			}
			
			$nameExplode=explode(' ',ltrim($comment->comment_author),3);
			$nameExplode=explode("'",ltrim($nameExplode[0]),3);// fix problem with 's
			
			$nameToMatch=$nameExplode[0];
			$lengthShortAuthor=strlen($nameToMatch);
			
			$match=0;
			if($lengthShortAuthor<2  ){ // after exploding, not enough remains to check.
				return $text;
			}
			
		    // ACTUAL COUNTING and CHECKING		
		    // check if they already shown
			for($i=0; $i<$numCommentsShownSoFar && $match!=1; $i++)
			{
				if( ($domainToMatch[2] == $commentAuthorsURL[$i]) && ($comment->comment_author_email == $commentAuthorsEmail[$i]) && $nameToMatch== $commentAuthorName[$i])
				{
					$match=1;
					$limited_count=$countForMatch[$i];
				}
			} // for i
			
			//  if there is no match, add to array so I can check next comment.
			if($match==0){
				$commentAuthorURL[$numCommentsShownSoFar]=$domainToMatch[2];
				$commentAuthorEmail[$numCommentsShownSoFar]=$comment->comment_author_email;
				$commentAuthorName[$numCommentsShownSoFar]=$nameToMatch;				
						
				if($comment->comment_type=='pingback' || $comment->comment_type=='trackback' ){ 
					$pingBack=1;
					$queryString="select count(1) as comments from $wpdb->comments where `comment_author_url` LIKE '%$domainToMatch[2]%' "; 
				}
				 else{
					$pingBack=0;
					$queryString="select count(1) as comments from $wpdb->comments where `comment_author_url` LIKE '%$domainToMatch[2]%' and `comment_author_email` = '$comment->comment_author_email' and `comment_author`  LIKE '%$nameToMatch%'"; 
				 }
				
					//echo('<br />'.$queryString.'<br />');
				$limited_count = $wpdb->get_var($queryString);				
				$countForMatch[$numCommentsShownSoFar]=$limited_count;	// remember how many matched
				$numCommentsShownSoFar++;
				
			} //($match ==0)			
		
			
			if( ($authorMatchNumber <= $limited_count  && $lengthAuthor<$maxCharactersInName ) || (3 <= $limited_count && $pingBack==1 ) ){ // follow! 
				
				$text = preg_replace("/(<a[^>]*[^\s])(\s*nofollow\s*)/i", "$1", $text);
				$text = preg_replace("/(<a[^>]*[^\s])(\s*rel=\"\s*\")/i", "$1", $text);
				$pattern='/external nofollow/';// 
				$replacement=' ';
				$text = preg_replace($pattern, $replacement,$text);
			}
			
			// if enough matches, follow comments.
			if( ( $commentsMatchNumber <= $limited_count) && (1 < $commentsMatchNumber) && $lengthAuthor<$maxCharactersInName && 3<$lengthEmail ){ 
				$noFollowingText=0;// do follows
				//echo('follow text ');
//				return $text;

			}
			else{ $noFollowingText=1; 
				//echo('no follow text<br />');
				$text = $comment->comment_author;
//				return $dudes_name;
			}
			
		}// if ($comment->comment_ID)
		
		if($sameNameExclude!=0){
			if($showCommentNumber!="No") $text .= " (".$limited_count.") ";
		}
		return $text;
	}// function adjust_nofollow_author($text = '')
	
	
    // ************  ************ at least cut out the second database call.
	function adjust_nofollow_text($text = ''){
		global $table_prefix, $wpdb, $comment, $noFollowingText, $supressHoboCustomLinkLove;
		if (isset($comment->comment_ID)){
			// remove any nofollows applied by some other function.	
			if($noFollowingText ==0 )
			{	
				//echo('follow text ');
				$text = preg_replace("/(<a[^>]*[^\s])(\s*nofollow\s*)/i", "$1", $text);
				$text = preg_replace("/(<a[^>]*[^\s])(\s*rel=\"\s*\")/i", "$1", $text);
				$pattern='/" rel="nofollow">/';
				$replacement='" >';
				$text = preg_replace($pattern, $replacement,$text);
			}
			else {  // this must be made to run *before* NoOldSpamLinks.  
				//echo('add follows to text');
				$text= addNoFollowToLinksInCommentsIfNew($text);
				$suppressChowLinksNoFollow=1; // if they are running chowlinks, this will prevent double insertion of nofollow and save cpu.
			}
		}// (isset($comment->comment_ID))
		return $text;
	}// function adjust_nofollow_text($text = '')
	
	
	// ************************ 
	function addNoFollowToLinksInCommentsIfNew($content) { 
	// This function will add nofollow to links in a comment. Logic must be applied before calling the function.
			
		$breakString='"http://'; 
		
		$content=str_ireplace_for_php4( "$breakString", "$breakString", $content);
		
		$pieces = explode($breakString, $content);
		
		if(count($pieces)==1){  }
		else {
			 for($j=1; $j<count($pieces); $j++){
				$parts= explode('>', $pieces[$j], 2);
					 if(1<count($parts)){$parts[1]=' rel="nofollow" >'.$parts[1];  }
					 else{				 $parts[0].=' rel="nofollow" ';}
					 
					 $pieces[$j] = implode($parts);
				}// for
			 }// else
		$content=implode( $breakString, $pieces);
			
	  return $content; 
	  } // addNoFollowToLinksInCommentsIfNew($content)
	  
	// ************************	  
	function str_ireplace_for_php4($search,$replace,$subject) 
	{
		$search = preg_quote($search, "/");
		return preg_replace("/".$search."/i", $replace, $subject); 
	} 
	
// END HOBO LINK LOVE
?>